import{S as Cs,i as Ds,s as As,e as t,k as i,w as G,t as o,M as Rs,c as r,d as e,m as h,a as n,x as J,h as l,b as p,G as s,g as D,y as K,L as Ms,q as X,o as Y,B as ss,v as Ts}from"../chunks/vendor-hf-doc-builder.js";import{I as Bs,C as $s}from"../chunks/CodeBlock-hf-doc-builder.js";function Zs(qs){let d,M,c,y,A,_,as,R,es,T,F,ts,B,m,f,j,rs,w,ns,os,ls,b,ps,g,ms,v,is,hs,k,ds,cs,fs,$,q,gs,E,us,ys,_s,x,js,S,P,ws,z,bs,vs,ks,I,Z;return _=new Bs({}),b=new $s({props:{code:`import pandas as pd

# Read a remote CSV file into a dataframe
df = pd.read_csv("hf://datasets/my-username/my-dataset-repo/train.csv")

# Write a dataframe to a remote CSV file
df.to_csv("hf://datasets/my-username/my-dataset-repo/test.csv")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> pandas <span class="hljs-keyword">as</span> pd

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Read a remote CSV file into a dataframe</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>df = pd.read_csv(<span class="hljs-string">&quot;hf://datasets/my-username/my-dataset-repo/train.csv&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Write a dataframe to a remote CSV file</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>df.to_csv(<span class="hljs-string">&quot;hf://datasets/my-username/my-dataset-repo/test.csv&quot;</span>)`}}),x=new $s({props:{code:`from hffs import HfFileSystem
import duckdb

fs = HfFileSystem()
duckdb.register_filesystem(fs)
# Query a remote file and get the result back as a dataframe
fs_query_file = "hf://datasets/my-username/my-dataset-repo/data_dir/data.parquet"
df = duckdb.query(f"SELECT * FROM '{fs_query_file}' LIMIT 10").df()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> hffs <span class="hljs-keyword">import</span> HfFileSystem
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> duckdb

<span class="hljs-meta">&gt;&gt;&gt; </span>fs = HfFileSystem()
<span class="hljs-meta">&gt;&gt;&gt; </span>duckdb.register_filesystem(fs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Query a remote file and get the result back as a dataframe</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>fs_query_file = <span class="hljs-string">&quot;hf://datasets/my-username/my-dataset-repo/data_dir/data.parquet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>df = duckdb.query(<span class="hljs-string">f&quot;SELECT * FROM &#x27;<span class="hljs-subst">{fs_query_file}</span>&#x27; LIMIT 10&quot;</span>).df()`}}),I=new $s({props:{code:`import numpy as np
import zarr

embeddings = np.random.randn(50000, 1000).astype("float32")

# Write an array to a repo
with zarr.open_group("hf://my-username/my-model-repo/array-store", mode="w") as root:
   foo = root.create_group("embeddings")
   foobar = foo.zeros('experiment_0', shape=(50000, 1000), chunks=(10000, 1000), dtype='f4')
   foobar[:] = embeddings

# Read an array from a repo
with zarr.open_group("hf://my-username/my-model-repo/array-store", mode="r") as root:
   first_row = root["embeddings/experiment_0"][0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> zarr

<span class="hljs-meta">&gt;&gt;&gt; </span>embeddings = np.random.randn(<span class="hljs-number">50000</span>, <span class="hljs-number">1000</span>).astype(<span class="hljs-string">&quot;float32&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Write an array to a repo</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> zarr.open_group(<span class="hljs-string">&quot;hf://my-username/my-model-repo/array-store&quot;</span>, mode=<span class="hljs-string">&quot;w&quot;</span>) <span class="hljs-keyword">as</span> root:
<span class="hljs-meta">... </span>   foo = root.create_group(<span class="hljs-string">&quot;embeddings&quot;</span>)
<span class="hljs-meta">... </span>   foobar = foo.zeros(<span class="hljs-string">&#x27;experiment_0&#x27;</span>, shape=(<span class="hljs-number">50000</span>, <span class="hljs-number">1000</span>), chunks=(<span class="hljs-number">10000</span>, <span class="hljs-number">1000</span>), dtype=<span class="hljs-string">&#x27;f4&#x27;</span>)
<span class="hljs-meta">... </span>   foobar[:] = embeddings

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Read an array from a repo</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> zarr.open_group(<span class="hljs-string">&quot;hf://my-username/my-model-repo/array-store&quot;</span>, mode=<span class="hljs-string">&quot;r&quot;</span>) <span class="hljs-keyword">as</span> root:
<span class="hljs-meta">... </span>   first_row = root[<span class="hljs-string">&quot;embeddings/experiment_0&quot;</span>][<span class="hljs-number">0</span>]`}}),{c(){d=t("meta"),M=i(),c=t("h1"),y=t("a"),A=t("span"),G(_.$$.fragment),as=i(),R=t("span"),es=o("Integration Zoo"),T=i(),F=t("p"),ts=o("Below is a (non-exhaustive) list of usage examples showcasing \u{1F917} Filesystem\u2019s interesting integrations:"),B=i(),m=t("ul"),f=t("li"),j=t("p"),rs=o("Reading/writing a "),w=t("a"),ns=o("Pandas"),os=o(" DataFrame from/to a \u{1F917} Hub repository:"),ls=i(),G(b.$$.fragment),ps=i(),g=t("p"),ms=o("The same workflow can also be used for "),v=t("a"),is=o("Dask"),hs=o(" and "),k=t("a"),ds=o("Polars"),cs=o(" DataFrames."),fs=i(),$=t("li"),q=t("p"),gs=o("Querying (remote) \u{1F917} Hub files with "),E=t("a"),us=o("DuckDB"),ys=o(":"),_s=i(),G(x.$$.fragment),js=i(),S=t("li"),P=t("p"),ws=o("Using \u{1F917} Hub as an array store with "),z=t("a"),bs=o("Zarr"),vs=o(":"),ks=i(),G(I.$$.fragment),this.h()},l(a){const u=Rs('[data-svelte="svelte-1phssyn"]',document.head);d=r(u,"META",{name:!0,content:!0}),u.forEach(e),M=h(a),c=r(a,"H1",{class:!0});var Q=n(c);y=r(Q,"A",{id:!0,class:!0,href:!0});var Es=n(y);A=r(Es,"SPAN",{});var xs=n(A);J(_.$$.fragment,xs),xs.forEach(e),Es.forEach(e),as=h(Q),R=r(Q,"SPAN",{});var Ss=n(R);es=l(Ss,"Integration Zoo"),Ss.forEach(e),Q.forEach(e),T=h(a),F=r(a,"P",{});var Ps=n(F);ts=l(Ps,"Below is a (non-exhaustive) list of usage examples showcasing \u{1F917} Filesystem\u2019s interesting integrations:"),Ps.forEach(e),B=h(a),m=r(a,"UL",{});var H=n(m);f=r(H,"LI",{});var L=n(f);j=r(L,"P",{});var U=n(j);rs=l(U,"Reading/writing a "),w=r(U,"A",{href:!0,rel:!0});var zs=n(w);ns=l(zs,"Pandas"),zs.forEach(e),os=l(U," DataFrame from/to a \u{1F917} Hub repository:"),U.forEach(e),ls=h(L),J(b.$$.fragment,L),ps=h(L),g=r(L,"P",{});var C=n(g);ms=l(C,"The same workflow can also be used for "),v=r(C,"A",{href:!0,rel:!0});var Is=n(v);is=l(Is,"Dask"),Is.forEach(e),hs=l(C," and "),k=r(C,"A",{href:!0,rel:!0});var Fs=n(k);ds=l(Fs,"Polars"),Fs.forEach(e),cs=l(C," DataFrames."),C.forEach(e),L.forEach(e),fs=h(H),$=r(H,"LI",{});var V=n($);q=r(V,"P",{});var W=n(q);gs=l(W,"Querying (remote) \u{1F917} Hub files with "),E=r(W,"A",{href:!0,rel:!0});var Hs=n(E);us=l(Hs,"DuckDB"),Hs.forEach(e),ys=l(W,":"),W.forEach(e),_s=h(V),J(x.$$.fragment,V),V.forEach(e),js=h(H),S=r(H,"LI",{});var N=n(S);P=r(N,"P",{});var O=n(P);ws=l(O,"Using \u{1F917} Hub as an array store with "),z=r(O,"A",{href:!0,rel:!0});var Ls=n(z);bs=l(Ls,"Zarr"),Ls.forEach(e),vs=l(O,":"),O.forEach(e),ks=h(N),J(I.$$.fragment,N),N.forEach(e),H.forEach(e),this.h()},h(){p(d,"name","hf:doc:metadata"),p(d,"content",JSON.stringify(Qs)),p(y,"id","integration-zoo"),p(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(y,"href","#integration-zoo"),p(c,"class","relative group"),p(w,"href","https://pandas.pydata.org/pandas-docs/stable/user_guide/io.html#reading-writing-remote-files"),p(w,"rel","nofollow"),p(v,"href","https://docs.dask.org/en/stable/how-to/connect-to-remote-data.html"),p(v,"rel","nofollow"),p(k,"href","https://pola-rs.github.io/polars/py-polars/html/reference/io.html"),p(k,"rel","nofollow"),p(E,"href","https://duckdb.org/docs/guides/python/filesystems"),p(E,"rel","nofollow"),p(z,"href","https://zarr.readthedocs.io/en/stable/tutorial.html#io-with-fsspec"),p(z,"rel","nofollow")},m(a,u){s(document.head,d),D(a,M,u),D(a,c,u),s(c,y),s(y,A),K(_,A,null),s(c,as),s(c,R),s(R,es),D(a,T,u),D(a,F,u),s(F,ts),D(a,B,u),D(a,m,u),s(m,f),s(f,j),s(j,rs),s(j,w),s(w,ns),s(j,os),s(f,ls),K(b,f,null),s(f,ps),s(f,g),s(g,ms),s(g,v),s(v,is),s(g,hs),s(g,k),s(k,ds),s(g,cs),s(m,fs),s(m,$),s($,q),s(q,gs),s(q,E),s(E,us),s(q,ys),s($,_s),K(x,$,null),s(m,js),s(m,S),s(S,P),s(P,ws),s(P,z),s(z,bs),s(P,vs),s(S,ks),K(I,S,null),Z=!0},p:Ms,i(a){Z||(X(_.$$.fragment,a),X(b.$$.fragment,a),X(x.$$.fragment,a),X(I.$$.fragment,a),Z=!0)},o(a){Y(_.$$.fragment,a),Y(b.$$.fragment,a),Y(x.$$.fragment,a),Y(I.$$.fragment,a),Z=!1},d(a){e(d),a&&e(M),a&&e(c),ss(_),a&&e(T),a&&e(F),a&&e(B),a&&e(m),ss(b),ss(x),ss(I)}}}const Qs={local:"integration-zoo",title:"Integration Zoo"};function Us(qs){return Ts(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ns extends Cs{constructor(d){super();Ds(this,d,Us,Zs,As,{})}}export{Ns as default,Qs as metadata};
